compile('avl.p');

define genavls1(s, l, p);
  lvars s, l, p;
  lvars vl = avls(l);
  lvars vp = avls(p);
  lvars i, j;
  for i in_vector vl do
    for j in_vector vp do
      [x ^i ^j ^s];
    endfor;
  endfor;
  datalength(vl)*datalength(vp);
enddefine; 

define genavls(k);
  lvars k, cnt, pom;
  genavls1(  1, k - 1, k - 2) -> cnt;
  genavls1(  0, k - 1, k - 1) -> pom;
  pom + cnt -> cnt;
  genavls1( -1, k - 2, k - 1) -> pom;
  pom + cnt -> cnt;
  consvector(cnt) -> avls(k);
enddefine;

3000000 -> popmemlim;

{{[]} {[x [] [] 0]} 0 0 0 0} -> avls;

for i from 3 to 6 do 
  genavls(i); 
endfor;

define fillavl(dz, k) ->(wd, wk);
lvars dz, k, wd = [], wk = k, poml, pomp;
  if dz /= [] then
    fillavl(dz(2), k) -> (poml, wk);
    wk + 2 -> k;
    fillavl(dz(3), k) -> (pomp, wk);
    [^k ^poml ^pomp ^(dz(4))] -> wd;
  endif;
enddefine;

/*
   For i = 6 this takes a lot of time, so we limit ourselfs to i <= 5
*/

for i from 3 to 5 do 
  printf(i, 'i = %p, ');
  printf(datalength(avls(i)), 'datalength(avls(i)) = %p\n');
  for d in_vector avls(i) do
    fillavl(d, 0) -> (a, l);
    for j from 0 by 2 to l do
      remtree(copyavltree(a), l) -> ;
    endfor;
  endfor;
endfor;
